//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#pragma link "rf65x.lib"
#include "rf65x_main_lt.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TRF65xTestForm *RF65xTestForm;

////////////////////////

DWORD   dwCOMSpeed[5] = {9600, 19200, 38400, 57600, 115200};

////////////////////////

FT_HANDLE          	       hRF65x			= INVALID_HANDLE_VALUE;
DWORD			       dwValue;
USHORT			       usMeasured;
RF65xHELLOANSWER	       hlans;
HMODULE                        hDLL                     = NULL;

////////////////////////


//---------------------------------------------------------------------------
__fastcall TRF65xTestForm::TRF65xTestForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TRF65xTestForm::ConnectButtonClick(TObject *Sender)
{
        DWORD dwCOMSpeed;

          if ( hRF65x == INVALID_HANDLE_VALUE)
          {
              memset(&hlans, 0x00, sizeof(RF65xHELLOANSWER));

              switch(COMSpeedComboBox->ItemIndex)
              {
                case 0:
                 dwCOMSpeed = CBR_9600;
                 break;
                case 1:
                 dwCOMSpeed = CBR_19200;
                 break;
                case 2:
                 dwCOMSpeed = CBR_38400;
                 break;
                case 3:
                 dwCOMSpeed = CBR_57600;
                 break;
                case 4:
                 dwCOMSpeed = CBR_115200;
                 break;
                default:
                 break;
              }

              if (!RF65x_FTDI_OpenPort(COMNameEdit->Text.c_str(), dwCOMSpeed, &hRF65x))
                return;

              if (RF65x_FTDI_HelloCmd( hRF65x, 1, &hlans ))
	        {
                        DeviceInfoLabel->Caption = "Device type: " + IntToStr(hlans.bDeviceType);
                        DevModLabel->Caption     = "Device modification: " + IntToStr(hlans.bDeviceModificaton);
                        DevSerialLabel->Caption  = "Device serial: " + IntToStr(hlans.wDeviceSerial);
                        DevMaxDistLabel->Caption = "Device max dist: " + IntToStr(hlans.wDeviceMaxDistance);
                        DevRangeLabel->Caption   = "Device range: " + IntToStr(hlans.wDeviceRange);
                        ConnectButton->Caption = "Disconnect";
                } else {
                        Application->MessageBox("Error: Check your COM settings...","Error",MB_ICONWARNING);
                        ConnectButton->Caption = "Connect";
                        RF65x_FTDI_ClosePort( hRF65x );
                        hRF65x                  = INVALID_HANDLE_VALUE;
                        return;
                }
          } else {
                RF65x_FTDI_ClosePort( hRF65x );
                hRF65x                  = INVALID_HANDLE_VALUE;
                ConnectButton->Caption  = "Connect";
          }
}
//---------------------------------------------------------------------------

void __fastcall TRF65xTestForm::FormDestroy(TObject *Sender)
{
        if ( hRF65x != INVALID_HANDLE_VALUE)
        {
                RF65x_FTDI_ClosePort( hRF65x );
                hRF65x = INVALID_HANDLE_VALUE;
        }

}
//---------------------------------------------------------------------------

void __fastcall TRF65xTestForm::MeasureButtonClick(TObject *Sender)
{
        AnsiString as;
        USHORT     usMeasuredVal;

        if ( hRF65x == INVALID_HANDLE_VALUE)
          return;

        if (RF65x_FTDI_Measure( hRF65x, DevCSpinEdit->Value, &usMeasuredVal))
        {
                as.sprintf("%.02f mm", (usMeasuredVal * hlans.wDeviceRange) / 16384.0f);
                MeasureLabel->Caption = as;
        }
}
//---------------------------------------------------------------------------

void __fastcall TRF65xTestForm::LockResultButtonClick(TObject *Sender)
{
        if ( hRF65x == INVALID_HANDLE_VALUE)
          return;

        RF65x_FTDI_LockResult( hRF65x, DevCSpinEdit->Value );
}
//---------------------------------------------------------------------------

void __fastcall TRF65xTestForm::StartStreamButtonClick(TObject *Sender)
{
        if ( hRF65x == INVALID_HANDLE_VALUE)
          return;

        MeasureTimer->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TRF65xTestForm::StopStreamButtonClick(TObject *Sender)
{
        if ( hRF65x == INVALID_HANDLE_VALUE)
          return;

        MeasureTimer->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TRF65xTestForm::MeasureTimerTimer(TObject *Sender)
{
        AnsiString as;
        USHORT     usMeasuredVal;

}
//---------------------------------------------------------------------------

