#include <windows.h>
#include <stdio.h>
#include "FTD2XX.H"

//////////////////////////////////////////////////////////////////////////

#define RF65x_INTERNAL_NAME	"RF56x"

//////////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
extern "C" {
#endif


/************************************************************************/
/* Structures                                                           */
/************************************************************************/


typedef struct _RF65x_HELLO_ANSWER_
{
	BYTE	bDeviceType;
	BYTE	bDeviceModificaton;
	WORD	wDeviceSerial;
	WORD	wDeviceMaxDistance;
	WORD	wDeviceRange;
} RF65xHELLOANSWER, *LPRF65xHELLOANSWER;

//////////////////////////////////////////////////////////////////////////

/************************************************************************/
/* Definitions                                                          */
/************************************************************************/

///////////////////////////////////////////////////////// Address / Length ////////////////
#define	RF65x_PARAMETER_POWER_STATE						((0x00) | ((0x01) << 8))
#define	RF65x_PARAMETER_PRIORITY_AND_SYNC				((0x02) | ((0x01) << 8))
#define	RF65x_PARAMETER_NETWORK_ADDRESS					((0x03) | ((0x01) << 8))
#define	RF65x_PARAMETER_BAUDRATE						((0x04) | ((0x01) << 8))
#define	RF65x_PARAMETER_AVERAGE_COUNT					((0x06) | ((0x01) << 8))
#define	RF65x_PARAMETER_SAMPLING_PERIOD					((0x08) | ((0x02) << 8))
#define	RF65x_PARAMETER_BEGIN_ANALOG_RANGE				((0x0C) | ((0x02) << 8))
#define	RF65x_PARAMETER_END_ANALOG_RANGE				((0x0E) | ((0x02) << 8))
#define	RF65x_PARAMETER_NOMINAL_VALUE					((0x17) | ((0x02) << 8))
#define	RF65x_PARAMETER_RESULT_AND_BORDER_TYPES			((0x1E) | ((0x01) << 8))
#define	RF65x_PARAMETER_NUM_CONTROLLED_BORDERS			((0x1F) | ((0x01) << 8))
#define	RF65x_PARAMETER_MINIMAL_TOLERANCE				((0x22) | ((0x02) << 8))
#define	RF65x_PARAMETER_MAXIMAL_TOLERANCE				((0x24) | ((0x02) << 8))
#define	RF65x_PARAMETER_OUTPUT_PINS_SETTINGS			((0x26) | ((0x01) << 8))

//////////////////////////////////////////////////////////////////////////

/************************************************************************/
/* Functions                                                            */
/************************************************************************/

/************************************************************************/
/* RS-232 functions                                                     */
/************************************************************************/

BOOL	RF65x_OpenPort(			
			LPCSTR					lpPort_Name, 
			DWORD					dwSpeed, 
			HANDLE *				lpHandle 
			);

BOOL	RF65x_ClosePort( 
			HANDLE					hHandle 
			);

BOOL	RF65x_HelloCmd(		
			HANDLE					hCOM, 
			BYTE					bAddress, 
			LPRF65xHELLOANSWER		lprfHelloAnswer 
			);

BOOL	RF65x_ReadParameter(		
			HANDLE					hCOM, 
			BYTE					bAddress, 
			WORD					wParameter,
			DWORD *					lpdwValue 
			);

BOOL	RF65x_WriteParameter(		
			HANDLE					hCOM, 
			BYTE					bAddress, 
			WORD					wParameter,
			DWORD					dwValue 
			);

BOOL	RF65x_ReadCustomParameter(		
			HANDLE					hCOM, 
			BYTE					bAddress, 
			BYTE					bParameterAddress,
			BYTE					bParameterSize,
			void *					lpValue 
			);

BOOL	RF65x_WriteCustomParameter(		
			HANDLE					hCOM, 
			BYTE					bAddress, 
			BYTE					bParameterAddress,
			BYTE					bParameterSize,
			void *					lpValue 
			);

BOOL	RF65x_FlushToFlash(		
			HANDLE					hCOM, 
			BYTE					bAddress
			);

BOOL	RF65x_RestoreFromFlash(		
			HANDLE					hCOM, 
			BYTE					bAddress
			);

BOOL	RF65x_LockResult(		
			HANDLE					hCOM, 
			BYTE					bAddress
			);

BOOL	RF65x_Measure(	
			HANDLE					hCOM, 
			BYTE					bAddress, 
			USHORT *				lpusValue 
			);

BOOL	RF65x_CustomCmd(	
			HANDLE					hCOM, 
			char *					pcInData, 
			DWORD					dwInSize, 
			char *					pcOutData, 
			DWORD *					pdwOutSize
			);

/************************************************************************/
/* FTDI functions		                                                */
/************************************************************************/

BOOL	RF65x_FTDI_OpenPort(		
			LPCSTR					lpPort_Name, 
			DWORD					dwSpeed, 
			FT_HANDLE *				lpftHandle 
			);

BOOL	RF65x_FTDI_ClosePort( 
			FT_HANDLE				hftHandle 
			);

BOOL	RF65x_FTDI_HelloCmd(	
			FT_HANDLE				hCOM, 
			BYTE					bAddress, 
			LPRF65xHELLOANSWER		lprfHelloAnswer 
			);

BOOL	RF65x_FTDI_ReadParameter(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress, 
			WORD					wParameter,
			DWORD *					lpdwValue 
			);

BOOL	RF65x_FTDI_WriteParameter(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress, 
			WORD					wParameter,
			DWORD					dwValue 
			);

BOOL	RF65x_FTDI_ReadCustomParameter(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress, 
			BYTE					bParameterAddress,
			BYTE					bParameterSize,
			void *					lpValue 
			);

BOOL	RF65x_FTDI_WriteCustomParameter(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress, 
			BYTE					bParameterAddress,
			BYTE					bParameterSize,
			void *					lpValue 
			);

BOOL	RF65x_FTDI_FlushToFlash(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress
			);

BOOL	RF65x_FTDI_RestoreFromFlash(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress
			);

BOOL	RF65x_FTDI_LockResult(		
			FT_HANDLE				hCOM, 
			BYTE					bAddress
			);

BOOL	RF65x_FTDI_Measure( 
			FT_HANDLE				hCOM, 
			BYTE					bAddress, 
			USHORT *				lpusValue 
			);

BOOL	RF65x_FTDI_CustomCmd( 
			FT_HANDLE			hCOM, 
			char *				pcInData, 
			DWORD				dwInSize, 
			char *				pcOutData, 
			DWORD *				pdwOutSize
			);

//////////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
}
#endif

//////////////////////////////////////////////////////////////////////////